/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.ProdukDto;
import com.portofolio.service.ProdukService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/produk")
public class ProdukController extends LocaleController {
    @Lazy
	@Autowired
    private ProdukService produkService;
    
    
    @ApiOperation("Api Untuk Menyimpan Produk")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody ProdukDto entity,HttpServletRequest request) {
        Map<String, Object> result = produkService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Produk")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdProduk", required = true) Integer kdProduk,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody ProdukDto entity, HttpServletRequest request) {
        Map<String, Object> result = produkService.update(entity,kdProduk,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Produk Berdasarkan KdProduk")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdProduk", required = true) Integer kdProduk,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = produkService.deleteById(kdProduk, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Produk")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaProduk") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaProduk", required = false) String namaProduk,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = produkService.grid(page, rows, sort, dir, namaProduk,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Produk Berdasarkan kdProduk")
    @GetMapping("/findByKdProduk")
    public ResponseEntity<Map<String, Object>> findByKdProduk(
    		@RequestParam(value = "kdProduk", required = true) Integer kdProduk, 
    		HttpServletRequest request) {
        Map<String, Object> result = produkService.findByKdProduk(kdProduk);
        return RestUtil.getJsonResponse(result);
    }


}
